searchData={"items":[{"type":"module","title":"VintageNetWireguard","doc":"Wireguard needs to configure an interface and peer connections for that\ninterface. Below is a list of the expected configuration parameters\nwhich are referenced from [`wg(8)`](https://git.zx2c4.com/wireguard-tools/about/src/man/wg.8)\nand [`wg-quick(8)`](https://git.zx2c4.com/wireguard-tools/about/src/man/wg-quick.8):\n\n#","ref":"VintageNetWireguard.html"},{"type":"module","title":"Interface - VintageNetWireguard","doc":"| Key | `wg` name | Required? | Description |\n| --- | --- | :---: | --- |\n| `:private_key` | `PrivateKey` | X | base64 private key for the interface registered with the server |\n| `:addresses` | `Address` | X | list of IP addresses for the connection to use (CIDR supported) |\n| `:listen_port` | `ListenPort` | | port for the connection. Randomly assigned if empty or `0` |\n| `:fwmark` | `FwMark` | | 32-bit fwmark for outgoing packets |\n| `:dns` | `DNS` | | list of DNS IP's |\n| `:peers` | `[PEER]` | | list of peer configs (see below) |\n\n#","ref":"VintageNetWireguard.html#module-interface"},{"type":"module","title":"Peer - VintageNetWireguard","doc":"| Key | `wg` name | Required? | Description |\n| --- | --- | :---: | --- |\n| `:public_key` | `PublicKey` | X | base64 public key |\n| `:endpoint` | `Endpoint` | X | endpoint to the wireguard server which the peer attempts to connect |\n| `:allowed_ips` | `AllowedIps` | X | list of IP addresses for allowed incoming packets and outgoing packets directed to. Defaults to `[\"0.0.0.0/0\", \"::0\"]` |\n| `:persistent_keepalive` | `PersistentKeepalive` | | optional integer seconds for sending an authenticated packet as a keepalive |","ref":"VintageNetWireguard.html#module-peer"},{"type":"module","title":"Using Wireguard Config Files - VintageNetWireguard","doc":"Wireguard commonly uses `*.conf` configuration files to simplify the setup\nprocess and `VintageNetWireguard` provides a helper function to parse those\nconfig files into the expected format:\n\n```elixir\niex)> config = VintageNetWireguard.ConfigFile.parse(\"/path/to/wg0.conf\")\niex)> VintageNet.configure(\"wg0\", config)\n```","ref":"VintageNetWireguard.html#module-using-wireguard-config-files"},{"type":"macro","title":"VintageNetWireguard.is_non_empty_string/1","doc":"","ref":"VintageNetWireguard.html#is_non_empty_string/1"},{"type":"function","title":"VintageNetWireguard.wg/0","doc":"Path to wg executable","ref":"VintageNetWireguard.html#wg/0"},{"type":"module","title":"VintageNetWireguard.ConfigFile","doc":"Helpers for dealing with a wireguard configuration file","ref":"VintageNetWireguard.ConfigFile.html"},{"type":"function","title":"VintageNetWireguard.ConfigFile.parse/1","doc":"Parse a Wireguard config file into a map","ref":"VintageNetWireguard.ConfigFile.html#parse/1"},{"type":"extras","title":"VintageNetWireguard","doc":"# VintageNetWireguard\n\n**Experimental**\n\nAn attempt to support Wireguard VPN peer connections on Nerves devices. See\nhttps://wireguard.com for more info","ref":"readme.html"},{"type":"extras","title":"Configuration - VintageNetWireguard","doc":"<!--- DOC !--->\nWireguard needs to configure an interface and peer connections for that\ninterface. Below is a list of the expected configuration parameters\nwhich are referenced from [`wg(8)`](https://git.zx2c4.com/wireguard-tools/about/src/man/wg.8)\nand [`wg-quick(8)`](https://git.zx2c4.com/wireguard-tools/about/src/man/wg-quick.8):\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"Interface - VintageNetWireguard","doc":"| Key | `wg` name | Required? | Description |\n| --- | --- | :---: | --- |\n| `:private_key` | `PrivateKey` | X | base64 private key for the interface registered with the server |\n| `:addresses` | `Address` | X | list of IP addresses for the connection to use (CIDR supported) |\n| `:listen_port` | `ListenPort` | | port for the connection. Randomly assigned if empty or `0` |\n| `:fwmark` | `FwMark` | | 32-bit fwmark for outgoing packets |\n| `:dns` | `DNS` | | list of DNS IP's |\n| `:peers` | `[PEER]` | | list of peer configs (see below) |\n\n#","ref":"readme.html#interface"},{"type":"extras","title":"Peer - VintageNetWireguard","doc":"| Key | `wg` name | Required? | Description |\n| --- | --- | :---: | --- |\n| `:public_key` | `PublicKey` | X | base64 public key |\n| `:endpoint` | `Endpoint` | X | endpoint to the wireguard server which the peer attempts to connect |\n| `:allowed_ips` | `AllowedIps` | X | list of IP addresses for allowed incoming packets and outgoing packets directed to. Defaults to `[\"0.0.0.0/0\", \"::0\"]` |\n| `:persistent_keepalive` | `PersistentKeepalive` | | optional integer seconds for sending an authenticated packet as a keepalive |","ref":"readme.html#peer"},{"type":"extras","title":"Using Wireguard Config Files - VintageNetWireguard","doc":"Wireguard commonly uses `*.conf` configuration files to simplify the setup\nprocess and `VintageNetWireguard` provides a helper function to parse those\nconfig files into the expected format:\n\n```elixir\niex)> config = VintageNetWireguard.ConfigFile.parse(\"/path/to/wg0.conf\")\niex)> VintageNet.configure(\"wg0\", config)\n```\n<!--- DOC !--->","ref":"readme.html#using-wireguard-config-files"},{"type":"extras","title":"Goals/Ideas - VintageNetWireguard","doc":"- [X] Setup `wg*` network interfaces\n- [ ] Notes/cookbook for setting up Wireguard server\n  - [ ] fly.io\n  - [ ] Another service?\n- [X] Parse wireguard peer configs\n- [ ] Potentially support authentication via other routes (i.e. NervesKey)\n- [ ] Mechanism for registering a new peer with remote server\n- [ ] Prevent storing private keys on disc","ref":"readme.html#goals-ideas"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [v0.2.0] - 2023-12-26\n\n#","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"* Scope logger messages to module\n* Include stderr with `wg` command output\n* Support OTP >= 25\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"* Ensure peer arg ordering is correct\n* Change `allowed-ips` to expected comma-separated list\n* Fix warnings for Elixir >= 1.15\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Updated - Changelog","doc":"* [wireguard-tools@13f4ac4](https://git.zx2c4.com/wireguard-tools/commit/?id=13f4ac4cb74b5a833fa7f825ba785b1e5774e84f)\n\n[v0.2.0]: https://github.com/nerves-networking/vintage_net_wireguard/releases/tag/v0.2.0\n\n## [v0.1.0] - 2022-02-22\n\nInitial release with support for starting a Wireguard client connection\n\nSee the [README.md](README.md) for more information on configuration\n\n#","ref":"changelog.html#updated"},{"type":"extras","title":"Added - Changelog","doc":"* `VintageNetWireguard.ConfigFile.parse/1` for parsing a Wireguard `*.conf` file\n  into the expected format for configuring with VintageNet\n* Compilation of [`wg(8)`](https://git.zx2c4.com/wireguard-tools/about/src/man/wg.8)\n  utility\n\n[v0.1.0]: https://github.com/nerves-networking/vintage_net_wireguard/releases/tag/v1.0.0","ref":"changelog.html#added"}],"content_type":"text/markdown"}